#include <windows.h>
#include <stdlib.h>

#include "upx.h"

#ifndef _IMAGEHLP_H 
#include "imagehlp.h"
#pragma comment ( lib, "imagehlp.lib" )
#endif

IMAGE_DOS_HEADER *DosHeader        = NULL;			//DOSͷ
IMAGE_NT_HEADERS *NtHeader         = NULL;			//NTͷ
IMAGE_FILE_HEADER *FileHeader      = NULL;		//ļͷ
IMAGE_OPTIONAL_HEADER32 *OptHeader = NULL;	//ѡͷ
IMAGE_SECTION_HEADER  *SecHeader   =NULL;
IMAGE_IMPORT_DESCRIPTOR *pIID      = NULL;		//Ŀ¼
DWORD dwImportBase;
PIMAGE_DOS_HEADER  GetDosHeader(LPVOID ImageBase)
{
//////////////////////////////ṹ
	PIMAGE_DOS_HEADER  pDosHeader = NULL;
/////////////////////////////DosHeaderṹ
	pDosHeader = (PIMAGE_DOS_HEADER)ImageBase;
	return pDosHeader;
}
PIMAGE_NT_HEADERS  GetNtHeader(LPVOID  ImageBase) 
{
//////////////////////////////ṹ
  PIMAGE_DOS_HEADER  pDosHeader = NULL;
  PIMAGE_NT_HEADERS  pNtHeader  = NULL;
/////////////////////////////NtHeaderṹ
  pDosHeader = (PIMAGE_DOS_HEADER)ImageBase;
  pNtHeader = (PIMAGE_NT_HEADERS32)((DWORD)pDosHeader+pDosHeader->e_lfanew);
  return    pNtHeader;
}

PIMAGE_FILE_HEADER GetFileHeader(LPVOID  ImageBase)
{
//////////////////////////////ṹ
  PIMAGE_DOS_HEADER  pDosHeader     = NULL;
  PIMAGE_NT_HEADERS  pNtHeader      = NULL;
  PIMAGE_FILE_HEADER  pFileHeader   = NULL;
/////////////////////////////FileHeaderṹ
  pDosHeader = (PIMAGE_DOS_HEADER)ImageBase;
  pNtHeader = (PIMAGE_NT_HEADERS32)((DWORD)pDosHeader+pDosHeader->e_lfanew);
  pFileHeader =(PIMAGE_FILE_HEADER)&pNtHeader->FileHeader;
  return  pFileHeader;
}
PIMAGE_OPTIONAL_HEADER  GetOptionalHeader(LPVOID  ImageBase)
{
//////////////////////////////ṹ
  PIMAGE_DOS_HEADER  pDosHeader         = NULL;
  PIMAGE_NT_HEADERS  pNtHeader          = NULL;
  PIMAGE_OPTIONAL_HEADER  pOptionHeader = NULL;
/////////////////////////////OptionalHeaderṹ
  pDosHeader = (PIMAGE_DOS_HEADER)ImageBase;
  pNtHeader = (PIMAGE_NT_HEADERS32)((DWORD)pDosHeader+pDosHeader->e_lfanew);
  pOptionHeader = (PIMAGE_OPTIONAL_HEADER32)&pNtHeader->OptionalHeader;
  return  pOptionHeader;
}
PIMAGE_SECTION_HEADER GetSectionHeader(LPVOID ImageBase)
{
//////////////////////////////ṹ
  PIMAGE_DOS_HEADER  pDosHeader         = NULL;
  PIMAGE_NT_HEADERS  pNtHeader          = NULL;
  PIMAGE_OPTIONAL_HEADER  pOptionHeader = NULL;
  PIMAGE_FILE_HEADER  pFileHeader       = NULL;
  PIMAGE_SECTION_HEADER pSecHeader      = NULL;
/////////////////////////////SectionHeaderṹ
  pDosHeader = (PIMAGE_DOS_HEADER)ImageBase;
  pNtHeader = (PIMAGE_NT_HEADERS32)((DWORD)pDosHeader+pDosHeader->e_lfanew);
  pFileHeader =(PIMAGE_FILE_HEADER)&pNtHeader->FileHeader; 
  pOptionHeader = (PIMAGE_OPTIONAL_HEADER)&pNtHeader->OptionalHeader;
  pSecHeader =(PIMAGE_SECTION_HEADER)((LPBYTE)pOptionHeader + pFileHeader->SizeOfOptionalHeader);
  return pSecHeader;
}
PIMAGE_IMPORT_DESCRIPTOR  GetFirstImportDesc(LPVOID  ImageBase)
{
//////////////////////////////ṹ
  PIMAGE_DOS_HEADER  pDosHeader         = NULL;
  PIMAGE_NT_HEADERS  pNtHeader          = NULL;
  PIMAGE_OPTIONAL_HEADER  pOptionHeader = NULL;
  PIMAGE_FILE_HEADER  pFileHeader       = NULL;
  PIMAGE_SECTION_HEADER pSecHeader      = NULL;
/////////////////////////////OptionalHeaderṹ
  pDosHeader = (PIMAGE_DOS_HEADER)ImageBase;
  pNtHeader = (PIMAGE_NT_HEADERS32)((DWORD)pDosHeader+pDosHeader->e_lfanew);
  pFileHeader =(PIMAGE_FILE_HEADER)&pNtHeader->FileHeader; 
  pOptionHeader = (PIMAGE_OPTIONAL_HEADER)&pNtHeader->OptionalHeader;  
  pSecHeader =(PIMAGE_SECTION_HEADER)((LPBYTE)pOptionHeader + pFileHeader->SizeOfOptionalHeader);
  DWORD pImportOffset = (pOptionHeader->DataDirectory[1]).VirtualAddress ;
  
  PIMAGE_IMPORT_DESCRIPTOR pImportDesc = (PIMAGE_IMPORT_DESCRIPTOR)
	ImageRvaToVa (pNtHeader,ImageBase,pImportOffset,&pSecHeader ) ; 
  return  pImportDesc;
}
////////////////////ȽǷΪPEļ
BOOL MemCmpPe(LPVOID ImageBase)
{
	PIMAGE_DOS_HEADER  pDosHeader =(PIMAGE_DOS_HEADER)ImageBase;
    PIMAGE_NT_HEADERS  pNtHeader  =(PIMAGE_NT_HEADERS32)((DWORD)pDosHeader+pDosHeader->e_lfanew);
	while(!ImageBase)
		return FALSE;
	while(pDosHeader->e_magic!=IMAGE_DOS_SIGNATURE)
		return FALSE;
	while(pNtHeader->Signature!=IMAGE_NT_SIGNATURE)
	    return FALSE;
	return TRUE;
}
///////////////////////////ȡļڴ
LPVOID MapFileToMemory(char *szFileName)
{
	HANDLE hFile = CreateFile(szFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile==INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL,"ܴļ","ʾ",MB_OK);
		return NULL;
	}
	HANDLE hMap = CreateFileMapping(hFile, NULL, PAGE_READONLY | SEC_COMMIT, 0, 0, NULL);
	LPVOID pMap = MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0);
	return pMap;
}
///////////////////////////öֵ
DWORD Alignment(DWORD Size,DWORD Align)
{
	if(Size%Align!=0)
		return  (Size/Align+1)*Align;
	return Size;
}
/////////////////////޸
void ModifySecName(PIMAGE_SECTION_HEADER SecHeader,DWORD SecNum)
{
	int i=0;
	while(i<SecNum)
	{
		strcpy((char*)SecHeader[i].Name,"UnPack");
		i++;
	}
}
///////////////////޸
void ModifyImport(DWORD SecOffset,DWORD SecOffsetA,DWORD SecOffsetB)
{
	DWORD SecOffsetC=SecOffset+SecOffsetA;
	DWORD ImPort    =*(DWORD*)SecOffsetC;
	while(ImPort)
	{
		DWORD FuncAddr  =*(DWORD*)(SecOffsetC+4);
		HMODULE hMod=LoadLibraryA((char*)SecOffsetB+ImPort);
		FuncAddr+=SecOffset;
		SecOffsetC+=8;
		while(*(BYTE*)SecOffsetC!=0)
		{
		    ++SecOffsetC;
		    *(DWORD*)FuncAddr=(DWORD)GetProcAddress(hMod,(char*)SecOffsetC);
		    FuncAddr+=4;
			SecOffsetC+=strlen((char*)SecOffsetC)+1;
		}
		++SecOffsetC;
		ImPort=*(DWORD*)SecOffsetC;
	}
}
////////////ڴ0xE8,0xE9//////////////CԱʾ///////////////е
void ModifyCall(BYTE *Start,int Size)
{
	BYTE DB;
	DWORD DDb;
	DWORD FixAddr=(DWORD)Start;
	WORD DWA;
	BYTE Hi8;
	WORD Lo8;
	while(Size)
	{
		DB=*(BYTE*)Start-0xE8;
		++Start;
		if(DB>1||*Start!=3)
		{
			continue;
		}
		DDb=*(DWORD*)Start;
		DWA=DDb&0x0ffff;
		DWA>>=8;
		DDb&=0xffff0000;
		DDb|=DWA;
		DDb=((DDb<<0x10)|(DDb>>0x10));
		DWA=DDb&0x0ffff;
		Lo8=((WORD)DWA<<8);
		Hi8=(BYTE)(DWA>>8);
		DWA=(Lo8+Hi8);
		DDb&=0xffff0000;
		DDb|=DWA;
		DDb-=(DWORD)Start;
		*(DWORD*)Start=DDb+FixAddr;
		Start+=4;
		--Size;
	}
}
///////////////////ζ
void SetSectionAlignment(IMAGE_SECTION_HEADER  *TempSecHeader,int SectionNum,DWORD SecValue)
{
	int AlignValue=0;
    for(int i=0;i<SectionNum;i++)
    {
		AlignValue=Alignment(TempSecHeader->Misc.VirtualSize, SecValue);
		TempSecHeader->SizeOfRawData   =AlignValue;
        TempSecHeader->Misc.VirtualSize=AlignValue;		
		TempSecHeader->PointerToRawData=TempSecHeader->VirtualAddress;
		TempSecHeader++;
    } 
}
BYTE PCode;                                                         //ѹĴļָ
BYTE *pImage;                                                       //µӳռ
DWORD ImageSize;                                                    //ӿǺӳС
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	DWORD dwWrite;
	LPBYTE lpFile=(LPBYTE)MapFileToMemory("Test.exe");
	if(MemCmpPe(lpFile)==FALSE)
	{
		MessageBoxA(NULL,"PEǩЧ","ʾ",MB_OK);
	}
	DosHeader    =GetDosHeader(lpFile);
	NtHeader     =GetNtHeader(lpFile);
	FileHeader   =GetFileHeader(lpFile);
	OptHeader    =GetOptionalHeader(lpFile);
	SecHeader    =GetSectionHeader(lpFile);
	pIID         =GetFirstImportDesc(lpFile);
/////////////////////һΣƵڴ
	ImageSize=Alignment(OptHeader->SizeOfImage,OptHeader->SectionAlignment);//üӿǺӳСҲռС
	pImage =VirtualAlloc(NULL,ImageSize,MEM_COMMIT,PAGE_READWRITE);         //µPEӳռ
	memcpy(pImage,lpFile,OptHeader->SizeOfHeaders);                         //PEͷ·ӳؼ
	IMAGE_SECTION_HEADER  *TempSecHeader   =SecHeader;                      //ʱνṹ
////////////////////θεµPEȥ
	for(int i=0;i<FileHeader->NumberOfSections;i++)                         //θƴ뵽µӳռ
	{
		memcpy(pImage+TempSecHeader->VirtualAddress,                        //մӳַ
			lpFile+TempSecHeader->PointerToRawData,                         //ƴļƫƵַ
			Alignment(TempSecHeader->SizeOfRawData,OptHeader->FileAlignment)//ƴСļСͶ
			);                                         
		++TempSecHeader;
	}
////////////////////ImagePEͷ
    IMAGE_NT_HEADERS *NewNtHeader         = GetNtHeader(pImage);	//NTͷ
    IMAGE_SECTION_HEADER  *NewSecHeader   = GetSectionHeader(pImage);
	IMAGE_OPTIONAL_HEADER *NewOptHeader    =GetOptionalHeader(pImage);
////////////////////ڵ
    NewNtHeader->OptionalHeader.AddressOfEntryPoint=0x1020;
////////////////////ļ뷽ʽ
    NewNtHeader->OptionalHeader.SizeOfImage   =Alignment(NewOptHeader->SizeOfImage,NewOptHeader->SectionAlignment);
    NewNtHeader->OptionalHeader.FileAlignment =NewOptHeader->FileAlignment;
    NewNtHeader->OptionalHeader.SizeOfHeaders =NewSecHeader->VirtualAddress; 
////////////////////λúʹС 
	SetSectionAlignment(NewSecHeader,NewNtHeader->FileHeader.NumberOfSections,0x1000);       //޸ζ
////////////////////ʼѹ
	UnCompress(pImage+SecHeader->VirtualAddress,(BYTE*)lpFile+SecHeader->PointerToRawData);      //ֻڴеѹѹӳռ
   //DisposureE8(pImage+SecHeader->VirtualAddress,0x84);                                      //ڴE8
	ModifyCall(pImage+SecHeader->VirtualAddress,0x84);
////////////////////޸
    ModifyImport((DWORD)pImage+0x1000,0x9000,(DWORD)pImage+0xC000); 
////////////////////޸
    ModifySecName(GetSectionHeader(pImage),3);                                                              
///////////////////дļ
	HANDLE Handle=CreateFile("UnpackMe.exe", GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	SetFilePointer(Handle,0,0,FILE_BEGIN);
	WriteFile(Handle,pImage,ImageSize,&dwWrite,NULL);
	MessageBox(NULL,"ѿǳɹ","UnpackMe",MB_OK);
	return TRUE;
}
